> For the complete documentation index, see [llms.txt](https://developers.polymath.network/polymath/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.polymath.network/polymath/api/securitytokenstorage.md).

# SecurityTokenStorage.sol

View Source: [contracts/tokens/SecurityTokenStorage.sol](https://github.com/PolymathNetwork/polymath-core/tree/096ba240a927c98e1f1a182d2efee7c4c4c1dfc5/contracts/tokens/SecurityTokenStorage.sol)

**↘ Derived Contracts:** [**SecurityToken**](https://github.com/PolymathNetwork/polymath-core/tree/096ba240a927c98e1f1a182d2efee7c4c4c1dfc5/docs/api/SecurityToken.md)**,** [**SecurityTokenProxy**](https://github.com/PolymathNetwork/polymath-core/tree/096ba240a927c98e1f1a182d2efee7c4c4c1dfc5/docs/api/SecurityTokenProxy.md)**,** [**STGetter**](https://github.com/PolymathNetwork/polymath-core/tree/096ba240a927c98e1f1a182d2efee7c4c4c1dfc5/docs/api/STGetter.md)

**SecurityTokenStorage**

## Structs

### Document

```javascript
struct Document {
 bytes32 docHash,
 uint256 lastModified,
 string uri
}
```

### SemanticVersion

```javascript
struct SemanticVersion {
 uint8 major,
 uint8 minor,
 uint8 patch
}
```

### ModuleData

```javascript
struct ModuleData {
 bytes32 name,
 address module,
 address moduleFactory,
 bool isArchived,
 uint8[] moduleTypes,
 uint256[] moduleIndexes,
 uint256 nameIndex,
 bytes32 label
}
```

### Checkpoint

```javascript
struct Checkpoint {
 uint256 checkpointId,
 uint256 value
}
```

## Contract Members

**Constants & Variables**

```javascript
//internal members
uint8 internal constant PERMISSION_KEY;
uint8 internal constant TRANSFER_KEY;
uint8 internal constant MINT_KEY;
uint8 internal constant CHECKPOINT_KEY;
uint8 internal constant BURN_KEY;
uint8 internal constant DATA_KEY;
uint8 internal constant WALLET_KEY;
bytes32 internal constant INVESTORSKEY;
bytes32 internal constant TREASURY;
bytes32 internal constant LOCKED;
bytes32 internal constant UNLOCKED;
address internal _owner;
bool internal issuance;
bytes32[] internal _docNames;
uint256[] internal checkpointTimes;
struct SecurityTokenStorage.SemanticVersion internal securityTokenVersion;
mapping(uint8 => address[]) internal modules;
mapping(address => struct SecurityTokenStorage.ModuleData) internal modulesToData;
mapping(bytes32 => address[]) internal names;
mapping(uint256 => uint256) internal checkpointTotalSupply;
mapping(address => struct SecurityTokenStorage.Checkpoint[]) internal checkpointBalances;
mapping(bytes32 => struct SecurityTokenStorage.Document) internal _documents;
mapping(bytes32 => uint256) internal _docIndexes;
mapping(address => mapping(bytes32 => mapping(address => bool))) internal partitionApprovals;

//public members
address public tokenFactory;
bool public initialized;
string public name;
string public symbol;
uint8 public decimals;
address public controller;
contract IPolymathRegistry public polymathRegistry;
contract IModuleRegistry public moduleRegistry;
contract ISecurityTokenRegistry public securityTokenRegistry;
contract IERC20 public polyToken;
address public getterDelegate;
contract IDataStore public dataStore;
uint256 public granularity;
uint256 public currentCheckpointId;
string public tokenDetails;
bool public controllerDisabled;
bool public transfersFrozen;
uint256 public holderCount;
```

## Functions


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.polymath.network/polymath/api/securitytokenstorage.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
